;*******************************************************
; Constants
; def = 0 regs nicht definiert
; def = 1 regs orginal definiert
; def = 2 regs ich definiert
; def = 3 regs tempXX definiert

;.equ const_Rx_LO = 0
;.equ const_Rx_HI = 0
;*******************************************************
;.def temp8	  	= R16;Status
;.def temp9		= R17;fr Bef

.def temp6	  	= R18
.def temp7		= R19

.def temp4 		= R20 
.def temp5	   	= R21   

.def temp2		= R22
.def temp3		= R23

.def temp0		= R24
.def temp1		= R25
;************************************************

;------------------------------------------------;
; Push/Pop register pair
;
.macro	pushw;x
	push	@0H
	push	@0L
.endm

.macro	popw;x
	pop	@0L
	pop	@0H
.endm

;------------------------------------------------;
; Load/store word from/to direct memory/immediate
;
.macro	ldiw;x,1000
	ldi	@0L,low(@1)
	ldi	@0H,high(@1)
.endm

.macro	ldsw;x,memADR
	lds	@0L,@1
	lds	@0H,@1+1
.endm

.macro	lddw;x,y+10
	ldd	@0L,@1
	ldd	@0H,@1+1
.endm

.macro	ldw;x,y+
	ld	@0L,@1
	ld	@0H,@1
.endm

.macro	stsw;memADR,x
	sts	@0,@1L
	sts	@0+1,@1H
.endm

.macro	stdw;y+10,x
	std	@0,@1L
	std	@0+1,@1H
.endm

.macro	stw;x+,y
	st	@0,@1L
	st	@0,@1H
.endm

.macro	outw
	out	@0H,@1H
	out	@0L,@1L
.endm

.macro	inw
	in	@0L,@1L
	in	@0H,@1H
.endm

;------------------------------------------------;
; add/sub/subc/cp/cpc/lsl/lsr/rol/ror to register pair

.macro	addiw
	subi	@0L,low(-(@1))
	sbci	@0H,high(-(@1))
.endm

.macro	subiw
	subi	@0L,low(@1)
	sbci	@0H,high(@1)
.endm

.macro	addw
	add	@0L,@1L
	adc	@0H,@1H
.endm

.macro	adcw
	adc	@0L,@1L
	adc	@0H,@1H
.endm

.macro	subw
	sub	@0L,@1L
	sbc	@0H,@1H
.endm

.macro	sbcw
	sbc	@0L,@1L
	sbc	@0H,@1H
.endm

.macro	cpw
	cp	@0L,@1L
	cpc	@0H,@1H
.endm

.macro	cpcw
	cpc	@0L,@1L
	cpc	@0H,@1H
.endm

.macro	cpiw
	cpi	@0L,low(@1)
	ldi	r16,high(@1) 
	cpc	@0H,r16
.endm

.macro	andw
	and	@0L,@1L
	and	@0H,@1H
.endm

.macro	andiw
	andi	@0L,low(@1)
	andi	@0H,high(@1)
.endm

.macro	orw
	or	@0L,@1L
	or	@0H,@1H
.endm

.macro	oriw
	ori	@0L,low(@1)
	ori	@0H,high(@1)
.endm

.macro	lslw
	lsl	@0L
	rol	@0H
.endm

.macro	lsrw
	lsr	@0H
	ror	@0L
.endm

.macro	asrw
	asr	@0H
	ror	@0L
.endm

.macro	rolw
	rol	@0L
	rol	@0H
.endm

.macro	rorw
	ror	@0H
	ror	@0L
.endm

.macro	clrw
	clr	@0L
	clr	@0H
.endm

.macro	comw
	com	@0L
	com	@0H
.endm

.macro	negw
	com	@0H
	neg	@0L
	brne	PC+2
	inc	@0H
.endm

.macro	movew
	mov	@0L, @1L
	mov	@0H, @1H
.endm

.macro	lpmw
	lpm	@0L, @1
	lpm	@0H, @1
.endm

;------------------------------------------------;
; Add immediate to register

.macro	addi
	subi	@0,-(@1)
.endm

;------------------------------------------------;
; Long branch wo_hin

.macro	rbrne	;Z=0 	Zero Flag 
	breq	PC+2
	rjmp	@0
.endm

.macro	rbreq	;Z=1	Zero Flag
	brne	PC+2
	rjmp	@0
.endm

.macro	rbrcc	;C=0	Carry Flag
	brcs	PC+2
	rjmp	@0
.endm

.macro	rbrcs	;C=1	Carry Flag
	brcc	PC+2
	rjmp	@0
.endm

.macro	rbrlo	;Z=0 	Zero Flag 
	brsh	PC+2
	rjmp	@0
.endm

.macro	rbrsh	;Z=1	Zero Flag
	brlo	PC+2
	rjmp	@0
.endm

.macro	rbrmi	;Z=0 	Zero Flag 
	brpl	PC+2
	rjmp	@0
.endm

.macro	rbrpl	;Z=1	Zero Flag
	brmi	PC+2
	rjmp	@0
.endm

.macro	rbrvc	;Z=0 	Zero Flag 
	brvs	PC+2
	rjmp	@0
.endm

.macro	rbrvs	;Z=1	Zero Flag
	brvc	PC+2
	rjmp	@0
.endm

.macro	rbrlt	;Z=0 	Zero Flag 
	brge	PC+2
	rjmp	@0
.endm

.macro	rbrge	;Z=1	Zero Flag
	brlt	PC+2
	rjmp	@0
.endm

.macro	rbrtc	;T=1	Transfer bit ->BLD and BST 
	brts	PC+2
	rjmp	@0
.endm

.macro	rbrts	;T=0	Transfer bit ->BLD and BST
	brtc	PC+2
	rjmp	@0
.endm

.macro	ret_brcc
	brcs	PC+2
	ret
.endm

.macro	ret_brcs
	brcc	PC+2
	ret
.endm

.macro	ret_breq
	brne	PC+2
	ret
.endm

.macro	ret_brne
	breq	PC+2
	ret
.endm

;------------------------------------------------;
; Move single bit between two registers
;
;	bmov	dstreg,dstbit,srcreg.srcbit

.macro	bmov
	bst	@2,@3
	bld	@0,@1
.endm

;------------------------------------------------;
; Move mem -> mem
;
; X/Y/Z = 16bit pointer 1  
; memQ = quelle
; X/Y/Z = 16bit pointer 2  
; memZ = ziel
; R_count = counter register
; R_help = r:hilf-register 
;	move_mem  X,memQ,Y,memZ,R_count,R_help  

.macro	move_mem
	ldi	@0L,low(@1)
	ldi	@0H,high(@1)
	ldi	@2L,low(@3)
	ldi	@2H,high(@3)
move_mem_rep:
	ld	@5,@0+
	st	@2+,@5	
	dec	@4
	brne	move_mem_rep
.endm

;------------------------------------------------;
; ADD-timer immediate 16 bit
;
; mem = daten-RAM
; 16bit-time = 1..65535
; Rx = r:hilf register	
; RRCC = prog adr bei berlauf
; add_timer_im_brcc  memADR-counter,16bit-time,Rx,BRCC  

.macro	add_timer_im_brcc
	lds	@2,@0
	subi	@2,low(-(@1))
	sts	@0,@2
	lds	@2,@0+1
	sbci	@2H,high(-(@1))
	sts	@0+1,@2
	brcs	PC+2
	rjmp	@3
.endm

;------------------------------------------------;
; ADD-timer 16 bit
;
; mem = daten-RAM
; mem-time = daten-RAM 1..65535
; Rx0 = r:hilf register 0	
; Rx1 = r:hilf register 1	
; RRCC = prog adr bei berlauf
; add_timer_brcc  memADR-counter,memADR-time,Rx0,Rx1,BRCC  

.macro	add_timer_brcc
	lds	@2,@0;lade mem-counter LO
	lds	@3,@1;lade mem-time LO
	add	@2,@3
	sts	@0,@2;save mem-counter LO
	lds	@2,@0+1;lade mem-counter HI
	lds	@3,@1+1;lade mem-time HI
	adc	@2H,@3
	sts	@0+1,@2;save mem-counter HI
	brcs	PC+2
	rjmp	@4
.endm


